/* HideTracker.c generated by valac 0.56.17, the Vala compiler
 * generated from HideTracker.vala, do not modify */

/*
 * Copyright 2024 elementary, Inc. (https://elementary.io)
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 * Authored by: Leonhard Kargl <leo.kargl@proton.me>
 */

#include <glib-object.h>
#include <meta/display.h>
#include "pantheon-desktop-shell-server-protocol.h"
#include <glib.h>
#include <meta/window.h>
#include <meta/meta-cursor-tracker.h>
#include <graphene-gobject.h>
#include <mtk/mtk.h>
#include <float.h>
#include <math.h>
#include <meta/meta-workspace-manager.h>
#include <meta/workspace.h>

#define GALA_HIDE_TRACKER_UPDATE_TIMEOUT ((guint) 200)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_HIDE_TRACKER (gala_hide_tracker_get_type ())
#define GALA_HIDE_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_HIDE_TRACKER, GalaHideTracker))
#define GALA_HIDE_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_HIDE_TRACKER, GalaHideTrackerClass))
#define GALA_IS_HIDE_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_HIDE_TRACKER))
#define GALA_IS_HIDE_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_HIDE_TRACKER))
#define GALA_HIDE_TRACKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_HIDE_TRACKER, GalaHideTrackerClass))

typedef struct _GalaHideTracker GalaHideTracker;
typedef struct _GalaHideTrackerClass GalaHideTrackerClass;
typedef struct _GalaHideTrackerPrivate GalaHideTrackerPrivate;

#define GALA_TYPE_PANEL_WINDOW (gala_panel_window_get_type ())
#define GALA_PANEL_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_PANEL_WINDOW, GalaPanelWindow))
#define GALA_PANEL_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_PANEL_WINDOW, GalaPanelWindowClass))
#define GALA_IS_PANEL_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_PANEL_WINDOW))
#define GALA_IS_PANEL_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_PANEL_WINDOW))
#define GALA_PANEL_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_PANEL_WINDOW, GalaPanelWindowClass))

typedef struct _GalaPanelWindow GalaPanelWindow;
typedef struct _GalaPanelWindowClass GalaPanelWindowClass;
enum  {
	GALA_HIDE_TRACKER_0_PROPERTY,
	GALA_HIDE_TRACKER_DISPLAY_PROPERTY,
	GALA_HIDE_TRACKER_PANEL_PROPERTY,
	GALA_HIDE_TRACKER_HIDE_MODE_PROPERTY,
	GALA_HIDE_TRACKER_NUM_PROPERTIES
};
static GParamSpec* gala_hide_tracker_properties[GALA_HIDE_TRACKER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block60Data Block60Data;
enum  {
	GALA_HIDE_TRACKER_HIDE_SIGNAL,
	GALA_HIDE_TRACKER_SHOW_SIGNAL,
	GALA_HIDE_TRACKER_NUM_SIGNALS
};
static guint gala_hide_tracker_signals[GALA_HIDE_TRACKER_NUM_SIGNALS] = {0};

struct _GalaHideTracker {
	GObject parent_instance;
	GalaHideTrackerPrivate * priv;
};

struct _GalaHideTrackerClass {
	GObjectClass parent_class;
};

struct _GalaHideTrackerPrivate {
	MetaDisplay* _display;
	GalaPanelWindow* _panel;
	enum io_elementary_pantheon_panel_v1_hide_mode _hide_mode;
	gboolean hovered;
	gboolean overlap;
	gboolean focus_overlap;
	gboolean focus_maximized_overlap;
	MetaWindow* current_focus_window;
	guint update_timeout_id;
};

struct _Block60Data {
	int _ref_count_;
	GalaHideTracker* self;
	gboolean has_transients;
};

static gint GalaHideTracker_private_offset;
static gpointer gala_hide_tracker_parent_class = NULL;

VALA_EXTERN GType gala_hide_tracker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaHideTracker, g_object_unref)
VALA_EXTERN GType gala_panel_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaPanelWindow, g_object_unref)
VALA_EXTERN GalaHideTracker* gala_hide_tracker_new (MetaDisplay* display,
                                        GalaPanelWindow* panel);
VALA_EXTERN GalaHideTracker* gala_hide_tracker_construct (GType object_type,
                                              MetaDisplay* display,
                                              GalaPanelWindow* panel);
static gboolean gala_hide_tracker_window_has_pointer (GalaHideTracker* self);
VALA_EXTERN MetaDisplay* gala_hide_tracker_get_display (GalaHideTracker* self);
VALA_EXTERN GalaPanelWindow* gala_hide_tracker_get_panel (GalaHideTracker* self);
VALA_EXTERN void gala_panel_window_get_custom_window_rect (GalaPanelWindow* self,
                                               MtkRectangle* result);
static void gala_hide_tracker_track_focus_window (GalaHideTracker* self,
                                           MetaWindow* window);
VALA_EXTERN void gala_hide_tracker_schedule_update (GalaHideTracker* self);
static void _gala_hide_tracker_schedule_update_meta_window_position_changed (MetaWindow* _sender,
                                                                      gpointer self);
static void _gala_hide_tracker_schedule_update_meta_window_size_changed (MetaWindow* _sender,
                                                                  gpointer self);
static void gala_hide_tracker_untrack_focus_window (GalaHideTracker* self,
                                             MetaWindow* window);
static gboolean __lambda103_ (GalaHideTracker* self);
static void gala_hide_tracker_update_overlap (GalaHideTracker* self);
static gboolean ___lambda103__gsource_func (gpointer self);
VALA_EXTERN MetaWindow* gala_panel_window_get_window (GalaPanelWindow* self);
static void gala_hide_tracker_update_hidden (GalaHideTracker* self);
VALA_EXTERN enum io_elementary_pantheon_panel_v1_hide_mode gala_hide_tracker_get_hide_mode (GalaHideTracker* self);
static void gala_hide_tracker_toggle_display (GalaHideTracker* self,
                                       gboolean should_hide);
static Block60Data* block60_data_ref (Block60Data* _data60_);
static void block60_data_unref (void * _userdata_);
static gboolean ___lambda104_ (Block60Data* _data60_);
static gboolean ____lambda104__meta_window_foreach_func (MetaWindow* window,
                                                  gpointer self);
static void gala_hide_tracker_set_display (GalaHideTracker* self,
                                    MetaDisplay* value);
static void gala_hide_tracker_set_panel (GalaHideTracker* self,
                                  GalaPanelWindow* value);
VALA_EXTERN void gala_hide_tracker_set_hide_mode (GalaHideTracker* self,
                                      enum io_elementary_pantheon_panel_v1_hide_mode value);
static GObject * gala_hide_tracker_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static void _gala_hide_tracker___lambda105_ (GalaHideTracker* self);
static void __gala_hide_tracker___lambda105__g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self);
static void _gala_hide_tracker___lambda106_ (GalaHideTracker* self,
                                      MetaWindow* window);
static void _gala_hide_tracker_schedule_update_meta_window_unmanaged (MetaWindow* _sender,
                                                               gpointer self);
static void __gala_hide_tracker___lambda106__meta_display_window_created (MetaDisplay* _sender,
                                                                   MetaWindow* object,
                                                                   gpointer self);
static void _gala_hide_tracker___lambda107_ (GalaHideTracker* self);
static void __gala_hide_tracker___lambda107__meta_cursor_tracker_position_invalidated (MetaCursorTracker* _sender,
                                                                                gpointer self);
static void _gala_hide_tracker_schedule_update_meta_workspace_manager_active_workspace_changed (MetaWorkspaceManager* _sender,
                                                                                         gpointer self);
static void gala_hide_tracker_finalize (GObject * obj);
static GType gala_hide_tracker_get_type_once (void);
static void _vala_gala_hide_tracker_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_gala_hide_tracker_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);

static inline gpointer
gala_hide_tracker_get_instance_private (GalaHideTracker* self)
{
	return G_STRUCT_MEMBER_P (self, GalaHideTracker_private_offset);
}

GalaHideTracker*
gala_hide_tracker_construct (GType object_type,
                             MetaDisplay* display,
                             GalaPanelWindow* panel)
{
	GalaHideTracker * self = NULL;
	g_return_val_if_fail (display != NULL, NULL);
	g_return_val_if_fail (panel != NULL, NULL);
	self = (GalaHideTracker*) g_object_new (object_type, "display", display, "panel", panel, NULL);
	return self;
}

GalaHideTracker*
gala_hide_tracker_new (MetaDisplay* display,
                       GalaPanelWindow* panel)
{
	return gala_hide_tracker_construct (GALA_TYPE_HIDE_TRACKER, display, panel);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gboolean
gala_hide_tracker_window_has_pointer (GalaHideTracker* self)
{
	MetaCursorTracker* cursor_tracker = NULL;
	MetaDisplay* _tmp0_;
	MetaCursorTracker* _tmp1_;
	MetaCursorTracker* _tmp2_;
	graphene_point_t pointer_pos = {0};
	graphene_point_t _tmp3_ = {0};
	MtkRectangle window_rect = {0};
	GalaPanelWindow* _tmp4_;
	MtkRectangle _tmp5_ = {0};
	graphene_rect_t graphene_window_rect = {0};
	MtkRectangle _tmp6_;
	MtkRectangle _tmp7_;
	MtkRectangle _tmp8_;
	MtkRectangle _tmp9_;
	graphene_rect_t _tmp10_ = {0};
	graphene_point_t _tmp11_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_display;
	_tmp1_ = meta_cursor_tracker_get_for_display (_tmp0_);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	cursor_tracker = _tmp2_;
	meta_cursor_tracker_get_pointer (cursor_tracker, &_tmp3_, NULL);
	pointer_pos = _tmp3_;
	_tmp4_ = self->priv->_panel;
	gala_panel_window_get_custom_window_rect (_tmp4_, &_tmp5_);
	window_rect = _tmp5_;
	_tmp6_ = window_rect;
	_tmp7_ = window_rect;
	_tmp8_ = window_rect;
	_tmp9_ = window_rect;
	_tmp10_.origin = (graphene_point_t) {(gfloat) _tmp6_.x, (gfloat) _tmp7_.y};
	_tmp10_.size = (graphene_size_t) {(gfloat) _tmp8_.width, (gfloat) _tmp9_.height};
	graphene_window_rect = _tmp10_;
	_tmp11_ = pointer_pos;
	result = graphene_rect_contains_point (&graphene_window_rect, &_tmp11_);
	_g_object_unref0 (cursor_tracker);
	return result;
}

static void
_gala_hide_tracker_schedule_update_meta_window_position_changed (MetaWindow* _sender,
                                                                 gpointer self)
{
	gala_hide_tracker_schedule_update ((GalaHideTracker*) self);
}

static void
_gala_hide_tracker_schedule_update_meta_window_size_changed (MetaWindow* _sender,
                                                             gpointer self)
{
	gala_hide_tracker_schedule_update ((GalaHideTracker*) self);
}

static void
gala_hide_tracker_track_focus_window (GalaHideTracker* self,
                                      MetaWindow* window)
{
	g_return_if_fail (self != NULL);
	if (window == NULL) {
		return;
	}
	g_signal_connect_object (window, "position-changed", (GCallback) _gala_hide_tracker_schedule_update_meta_window_position_changed, self, 0);
	g_signal_connect_object (window, "size-changed", (GCallback) _gala_hide_tracker_schedule_update_meta_window_size_changed, self, 0);
	gala_hide_tracker_schedule_update (self);
}

static void
gala_hide_tracker_untrack_focus_window (GalaHideTracker* self,
                                        MetaWindow* window)
{
	guint _tmp0_;
	guint _tmp1_;
	g_return_if_fail (self != NULL);
	if (window == NULL) {
		return;
	}
	g_signal_parse_name ("position-changed", meta_window_get_type (), &_tmp0_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (window, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _gala_hide_tracker_schedule_update_meta_window_position_changed, self);
	g_signal_parse_name ("size-changed", meta_window_get_type (), &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (window, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _gala_hide_tracker_schedule_update_meta_window_size_changed, self);
	gala_hide_tracker_schedule_update (self);
}

static gboolean
__lambda103_ (GalaHideTracker* self)
{
	gboolean result;
	gala_hide_tracker_update_overlap (self);
	self->priv->update_timeout_id = (guint) 0;
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
___lambda103__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda103_ ((GalaHideTracker*) self);
	return result;
}

void
gala_hide_tracker_schedule_update (GalaHideTracker* self)
{
	g_return_if_fail (self != NULL);
	if (self->priv->update_timeout_id != ((guint) 0)) {
		return;
	}
	self->priv->update_timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT, GALA_HIDE_TRACKER_UPDATE_TIMEOUT, ___lambda103__gsource_func, g_object_ref (self), g_object_unref);
}

static void
gala_hide_tracker_update_overlap (GalaHideTracker* self)
{
	MetaDisplay* _tmp0_;
	MetaWorkspaceManager* _tmp1_;
	MetaWorkspace* _tmp2_;
	GList* _tmp3_;
	g_return_if_fail (self != NULL);
	self->priv->overlap = FALSE;
	self->priv->focus_overlap = FALSE;
	self->priv->focus_maximized_overlap = FALSE;
	_tmp0_ = self->priv->_display;
	_tmp1_ = meta_display_get_workspace_manager (_tmp0_);
	_tmp2_ = meta_workspace_manager_get_active_workspace (_tmp1_);
	_tmp3_ = meta_workspace_list_windows (_tmp2_);
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp3_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			MetaWindow* window = NULL;
			window = (MetaWindow*) window_it->data;
			{
				MetaWindow* _tmp4_;
				GalaPanelWindow* _tmp5_;
				MetaWindow* _tmp6_;
				MetaWindow* _tmp7_;
				MetaWindow* _tmp8_;
				gboolean _tmp9_;
				gboolean _tmp10_;
				MetaWindowType type = 0;
				MetaWindow* _tmp11_;
				gboolean _tmp12_ = FALSE;
				gboolean _tmp13_ = FALSE;
				gboolean _tmp14_ = FALSE;
				GalaPanelWindow* _tmp15_;
				MtkRectangle _tmp16_ = {0};
				MetaWindow* _tmp17_;
				MtkRectangle _tmp18_ = {0};
				MetaWindow* _tmp19_;
				MetaDisplay* _tmp20_;
				MetaWindow* _tmp21_;
				MetaWindow* _tmp22_;
				MetaWindow* _tmp23_;
				_tmp4_ = window;
				_tmp5_ = self->priv->_panel;
				_tmp6_ = gala_panel_window_get_window (_tmp5_);
				_tmp7_ = _tmp6_;
				if (_tmp4_ == _tmp7_) {
					continue;
				}
				_tmp8_ = window;
				g_object_get (_tmp8_, "minimized", &_tmp9_, NULL);
				_tmp10_ = _tmp9_;
				if (_tmp10_) {
					continue;
				}
				_tmp11_ = window;
				type = meta_window_get_window_type (_tmp11_);
				if (type == META_WINDOW_DESKTOP) {
					_tmp14_ = TRUE;
				} else {
					_tmp14_ = type == META_WINDOW_DOCK;
				}
				if (_tmp14_) {
					_tmp13_ = TRUE;
				} else {
					_tmp13_ = type == META_WINDOW_MENU;
				}
				if (_tmp13_) {
					_tmp12_ = TRUE;
				} else {
					_tmp12_ = type == META_WINDOW_SPLASHSCREEN;
				}
				if (_tmp12_) {
					continue;
				}
				_tmp15_ = self->priv->_panel;
				gala_panel_window_get_custom_window_rect (_tmp15_, &_tmp16_);
				_tmp17_ = window;
				meta_window_get_frame_rect (_tmp17_, &_tmp18_);
				if (!mtk_rectangle_overlap (&_tmp16_, &_tmp18_)) {
					continue;
				}
				self->priv->overlap = TRUE;
				_tmp19_ = window;
				_tmp20_ = self->priv->_display;
				_tmp21_ = meta_display_get_focus_window (_tmp20_);
				_tmp22_ = _tmp21_;
				if (_tmp19_ != _tmp22_) {
					continue;
				}
				self->priv->focus_overlap = TRUE;
				_tmp23_ = window;
				self->priv->focus_maximized_overlap = meta_window_get_maximized (_tmp23_) == META_MAXIMIZE_BOTH;
			}
		}
		(window_collection == NULL) ? NULL : (window_collection = (g_list_free (window_collection), NULL));
	}
	gala_hide_tracker_update_hidden (self);
}

static void
gala_hide_tracker_update_hidden (GalaHideTracker* self)
{
	enum io_elementary_pantheon_panel_v1_hide_mode _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_hide_mode;
	switch (_tmp0_) {
		case IO_ELEMENTARY_PANTHEON_PANEL_V1_HIDE_MODE_NEVER:
		{
			gala_hide_tracker_toggle_display (self, FALSE);
			break;
		}
		case IO_ELEMENTARY_PANTHEON_PANEL_V1_HIDE_MODE_MAXIMIZED_FOCUS_WINDOW:
		{
			gala_hide_tracker_toggle_display (self, self->priv->focus_maximized_overlap);
			break;
		}
		case IO_ELEMENTARY_PANTHEON_PANEL_V1_HIDE_MODE_OVERLAPPING_FOCUS_WINDOW:
		{
			gala_hide_tracker_toggle_display (self, self->priv->focus_overlap);
			break;
		}
		case IO_ELEMENTARY_PANTHEON_PANEL_V1_HIDE_MODE_OVERLAPPING_WINDOW:
		{
			gala_hide_tracker_toggle_display (self, self->priv->overlap);
			break;
		}
		case IO_ELEMENTARY_PANTHEON_PANEL_V1_HIDE_MODE_ALWAYS:
		{
			gala_hide_tracker_toggle_display (self, TRUE);
			break;
		}
		default:
		break;
	}
}

static Block60Data*
block60_data_ref (Block60Data* _data60_)
{
	g_atomic_int_inc (&_data60_->_ref_count_);
	return _data60_;
}

static void
block60_data_unref (void * _userdata_)
{
	Block60Data* _data60_;
	_data60_ = (Block60Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data60_->_ref_count_)) {
		GalaHideTracker* self;
		self = _data60_->self;
		_g_object_unref0 (self);
		g_slice_free (Block60Data, _data60_);
	}
}

static gboolean
___lambda104_ (Block60Data* _data60_)
{
	GalaHideTracker* self;
	gboolean result;
	self = _data60_->self;
	_data60_->has_transients = TRUE;
	result = FALSE;
	return result;
}

static gboolean
____lambda104__meta_window_foreach_func (MetaWindow* window,
                                         gpointer self)
{
	gboolean result;
	result = ___lambda104_ (self);
	return result;
}

static void
gala_hide_tracker_toggle_display (GalaHideTracker* self,
                                  gboolean should_hide)
{
	GalaPanelWindow* _tmp0_;
	MetaWindow* _tmp1_;
	MetaWindow* _tmp2_;
	gboolean _tmp3_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_panel;
	_tmp1_ = gala_panel_window_get_window (_tmp0_);
	_tmp2_ = _tmp1_;
	self->priv->hovered = meta_window_has_pointer (_tmp2_);
	if (should_hide) {
		_tmp3_ = !self->priv->hovered;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		Block60Data* _data60_;
		GalaPanelWindow* _tmp4_;
		MetaWindow* _tmp5_;
		MetaWindow* _tmp6_;
		_data60_ = g_slice_new0 (Block60Data);
		_data60_->_ref_count_ = 1;
		_data60_->self = g_object_ref (self);
		_data60_->has_transients = FALSE;
		_tmp4_ = self->priv->_panel;
		_tmp5_ = gala_panel_window_get_window (_tmp4_);
		_tmp6_ = _tmp5_;
		meta_window_foreach_transient (_tmp6_, ____lambda104__meta_window_foreach_func, _data60_);
		if (_data60_->has_transients) {
			block60_data_unref (_data60_);
			_data60_ = NULL;
			return;
		}
		g_signal_emit (self, gala_hide_tracker_signals[GALA_HIDE_TRACKER_HIDE_SIGNAL], 0);
		block60_data_unref (_data60_);
		_data60_ = NULL;
	} else {
		g_signal_emit (self, gala_hide_tracker_signals[GALA_HIDE_TRACKER_SHOW_SIGNAL], 0);
	}
}

MetaDisplay*
gala_hide_tracker_get_display (GalaHideTracker* self)
{
	MetaDisplay* result;
	MetaDisplay* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_display;
	result = _tmp0_;
	return result;
}

static void
gala_hide_tracker_set_display (GalaHideTracker* self,
                               MetaDisplay* value)
{
	MetaDisplay* old_value;
	g_return_if_fail (self != NULL);
	old_value = gala_hide_tracker_get_display (self);
	if (old_value != value) {
		MetaDisplay* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_display);
		self->priv->_display = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gala_hide_tracker_properties[GALA_HIDE_TRACKER_DISPLAY_PROPERTY]);
	}
}

GalaPanelWindow*
gala_hide_tracker_get_panel (GalaHideTracker* self)
{
	GalaPanelWindow* result;
	GalaPanelWindow* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_panel;
	result = _tmp0_;
	return result;
}

static void
gala_hide_tracker_set_panel (GalaHideTracker* self,
                             GalaPanelWindow* value)
{
	GalaPanelWindow* old_value;
	g_return_if_fail (self != NULL);
	old_value = gala_hide_tracker_get_panel (self);
	if (old_value != value) {
		self->priv->_panel = value;
		g_object_notify_by_pspec ((GObject *) self, gala_hide_tracker_properties[GALA_HIDE_TRACKER_PANEL_PROPERTY]);
	}
}

enum io_elementary_pantheon_panel_v1_hide_mode
gala_hide_tracker_get_hide_mode (GalaHideTracker* self)
{
	enum io_elementary_pantheon_panel_v1_hide_mode result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_hide_mode;
	return result;
}

void
gala_hide_tracker_set_hide_mode (GalaHideTracker* self,
                                 enum io_elementary_pantheon_panel_v1_hide_mode value)
{
	enum io_elementary_pantheon_panel_v1_hide_mode old_value;
	g_return_if_fail (self != NULL);
	old_value = gala_hide_tracker_get_hide_mode (self);
	if (old_value != value) {
		self->priv->_hide_mode = value;
		g_object_notify_by_pspec ((GObject *) self, gala_hide_tracker_properties[GALA_HIDE_TRACKER_HIDE_MODE_PROPERTY]);
	}
}

static void
_gala_hide_tracker___lambda105_ (GalaHideTracker* self)
{
	MetaWindow* _tmp0_;
	MetaDisplay* _tmp1_;
	MetaWindow* _tmp2_;
	MetaWindow* _tmp3_;
	MetaWindow* _tmp4_;
	MetaWindow* _tmp5_;
	_tmp0_ = self->priv->current_focus_window;
	gala_hide_tracker_untrack_focus_window (self, _tmp0_);
	_tmp1_ = self->priv->_display;
	_tmp2_ = meta_display_get_focus_window (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = _g_object_ref0 (_tmp3_);
	_g_object_unref0 (self->priv->current_focus_window);
	self->priv->current_focus_window = _tmp4_;
	_tmp5_ = self->priv->current_focus_window;
	gala_hide_tracker_track_focus_window (self, _tmp5_);
}

static void
__gala_hide_tracker___lambda105__g_object_notify (GObject* _sender,
                                                  GParamSpec* pspec,
                                                  gpointer self)
{
	_gala_hide_tracker___lambda105_ ((GalaHideTracker*) self);
}

static void
_gala_hide_tracker_schedule_update_meta_window_unmanaged (MetaWindow* _sender,
                                                          gpointer self)
{
	gala_hide_tracker_schedule_update ((GalaHideTracker*) self);
}

static void
_gala_hide_tracker___lambda106_ (GalaHideTracker* self,
                                 MetaWindow* window)
{
	g_return_if_fail (window != NULL);
	gala_hide_tracker_schedule_update (self);
	g_signal_connect_object (window, "unmanaged", (GCallback) _gala_hide_tracker_schedule_update_meta_window_unmanaged, self, 0);
}

static void
__gala_hide_tracker___lambda106__meta_display_window_created (MetaDisplay* _sender,
                                                              MetaWindow* object,
                                                              gpointer self)
{
	_gala_hide_tracker___lambda106_ ((GalaHideTracker*) self, object);
}

static void
_gala_hide_tracker___lambda107_ (GalaHideTracker* self)
{
	gboolean has_pointer = FALSE;
	GalaPanelWindow* _tmp0_;
	MetaWindow* _tmp1_;
	MetaWindow* _tmp2_;
	_tmp0_ = self->priv->_panel;
	_tmp1_ = gala_panel_window_get_window (_tmp0_);
	_tmp2_ = _tmp1_;
	has_pointer = meta_window_has_pointer (_tmp2_);
	if (self->priv->hovered != has_pointer) {
		self->priv->hovered = has_pointer;
		gala_hide_tracker_schedule_update (self);
	}
}

static void
__gala_hide_tracker___lambda107__meta_cursor_tracker_position_invalidated (MetaCursorTracker* _sender,
                                                                           gpointer self)
{
	_gala_hide_tracker___lambda107_ ((GalaHideTracker*) self);
}

static void
_gala_hide_tracker_schedule_update_meta_workspace_manager_active_workspace_changed (MetaWorkspaceManager* _sender,
                                                                                    gpointer self)
{
	gala_hide_tracker_schedule_update ((GalaHideTracker*) self);
}

static GObject *
gala_hide_tracker_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaHideTracker * self;
	MetaDisplay* _tmp0_;
	MetaWindow* _tmp1_;
	MetaWindow* _tmp2_;
	MetaWindow* _tmp3_;
	MetaWindow* _tmp4_;
	MetaDisplay* _tmp5_;
	MetaDisplay* _tmp6_;
	MetaCursorTracker* cursor_tracker = NULL;
	MetaDisplay* _tmp7_;
	MetaCursorTracker* _tmp8_;
	MetaCursorTracker* _tmp9_;
	MetaCursorTracker* _tmp10_;
	MetaDisplay* _tmp11_;
	MetaWorkspaceManager* _tmp12_;
	parent_class = G_OBJECT_CLASS (gala_hide_tracker_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_HIDE_TRACKER, GalaHideTracker);
	_tmp0_ = self->priv->_display;
	_tmp1_ = meta_display_get_focus_window (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	_g_object_unref0 (self->priv->current_focus_window);
	self->priv->current_focus_window = _tmp3_;
	_tmp4_ = self->priv->current_focus_window;
	gala_hide_tracker_track_focus_window (self, _tmp4_);
	_tmp5_ = self->priv->_display;
	g_signal_connect_object ((GObject*) _tmp5_, "notify::focus-window", (GCallback) __gala_hide_tracker___lambda105__g_object_notify, self, 0);
	_tmp6_ = self->priv->_display;
	g_signal_connect_object (_tmp6_, "window-created", (GCallback) __gala_hide_tracker___lambda106__meta_display_window_created, self, 0);
	_tmp7_ = self->priv->_display;
	_tmp8_ = meta_cursor_tracker_get_for_display (_tmp7_);
	_tmp9_ = _g_object_ref0 (_tmp8_);
	cursor_tracker = _tmp9_;
	_tmp10_ = cursor_tracker;
	g_signal_connect_object (_tmp10_, "position-invalidated", (GCallback) __gala_hide_tracker___lambda107__meta_cursor_tracker_position_invalidated, self, 0);
	_tmp11_ = self->priv->_display;
	_tmp12_ = meta_display_get_workspace_manager (_tmp11_);
	g_signal_connect_object (_tmp12_, "active-workspace-changed", (GCallback) _gala_hide_tracker_schedule_update_meta_workspace_manager_active_workspace_changed, self, 0);
	_g_object_unref0 (cursor_tracker);
	return obj;
}

static void
gala_hide_tracker_class_init (GalaHideTrackerClass * klass,
                              gpointer klass_data)
{
	gala_hide_tracker_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GalaHideTracker_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_hide_tracker_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_hide_tracker_set_property;
	G_OBJECT_CLASS (klass)->constructor = gala_hide_tracker_constructor;
	G_OBJECT_CLASS (klass)->finalize = gala_hide_tracker_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_HIDE_TRACKER_DISPLAY_PROPERTY, gala_hide_tracker_properties[GALA_HIDE_TRACKER_DISPLAY_PROPERTY] = g_param_spec_object ("display", "display", "display", meta_display_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_HIDE_TRACKER_PANEL_PROPERTY, gala_hide_tracker_properties[GALA_HIDE_TRACKER_PANEL_PROPERTY] = g_param_spec_object ("panel", "panel", "panel", GALA_TYPE_PANEL_WINDOW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_HIDE_TRACKER_HIDE_MODE_PROPERTY, gala_hide_tracker_properties[GALA_HIDE_TRACKER_HIDE_MODE_PROPERTY] = g_param_spec_int ("hide-mode", "hide-mode", "hide-mode", G_MININT, G_MAXINT, IO_ELEMENTARY_PANTHEON_PANEL_V1_HIDE_MODE_NEVER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	gala_hide_tracker_signals[GALA_HIDE_TRACKER_HIDE_SIGNAL] = g_signal_new ("hide", GALA_TYPE_HIDE_TRACKER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	gala_hide_tracker_signals[GALA_HIDE_TRACKER_SHOW_SIGNAL] = g_signal_new ("show", GALA_TYPE_HIDE_TRACKER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
gala_hide_tracker_instance_init (GalaHideTracker * self,
                                 gpointer klass)
{
	self->priv = gala_hide_tracker_get_instance_private (self);
	self->priv->_hide_mode = IO_ELEMENTARY_PANTHEON_PANEL_V1_HIDE_MODE_NEVER;
	self->priv->hovered = FALSE;
	self->priv->overlap = FALSE;
	self->priv->focus_overlap = FALSE;
	self->priv->focus_maximized_overlap = FALSE;
	self->priv->update_timeout_id = (guint) 0;
}

static void
gala_hide_tracker_finalize (GObject * obj)
{
	GalaHideTracker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_HIDE_TRACKER, GalaHideTracker);
	_g_object_unref0 (self->priv->_display);
	_g_object_unref0 (self->priv->current_focus_window);
	G_OBJECT_CLASS (gala_hide_tracker_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
gala_hide_tracker_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaHideTrackerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_hide_tracker_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaHideTracker), 0, (GInstanceInitFunc) gala_hide_tracker_instance_init, NULL };
	GType gala_hide_tracker_type_id;
	gala_hide_tracker_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaHideTracker", &g_define_type_info, 0);
	GalaHideTracker_private_offset = g_type_add_instance_private (gala_hide_tracker_type_id, sizeof (GalaHideTrackerPrivate));
	return gala_hide_tracker_type_id;
}

GType
gala_hide_tracker_get_type (void)
{
	static gsize gala_hide_tracker_type_id__once = 0;
	if (g_once_init_enter (&gala_hide_tracker_type_id__once)) {
		GType gala_hide_tracker_type_id;
		gala_hide_tracker_type_id = gala_hide_tracker_get_type_once ();
		g_once_init_leave (&gala_hide_tracker_type_id__once, gala_hide_tracker_type_id);
	}
	return gala_hide_tracker_type_id__once;
}

static void
_vala_gala_hide_tracker_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	GalaHideTracker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_HIDE_TRACKER, GalaHideTracker);
	switch (property_id) {
		case GALA_HIDE_TRACKER_DISPLAY_PROPERTY:
		g_value_set_object (value, gala_hide_tracker_get_display (self));
		break;
		case GALA_HIDE_TRACKER_PANEL_PROPERTY:
		g_value_set_object (value, gala_hide_tracker_get_panel (self));
		break;
		case GALA_HIDE_TRACKER_HIDE_MODE_PROPERTY:
		g_value_set_int (value, gala_hide_tracker_get_hide_mode (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_gala_hide_tracker_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	GalaHideTracker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_HIDE_TRACKER, GalaHideTracker);
	switch (property_id) {
		case GALA_HIDE_TRACKER_DISPLAY_PROPERTY:
		gala_hide_tracker_set_display (self, g_value_get_object (value));
		break;
		case GALA_HIDE_TRACKER_PANEL_PROPERTY:
		gala_hide_tracker_set_panel (self, g_value_get_object (value));
		break;
		case GALA_HIDE_TRACKER_HIDE_MODE_PROPERTY:
		gala_hide_tracker_set_hide_mode (self, g_value_get_int (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

