/* PanelWindow.c generated by valac 0.56.17, the Vala compiler
 * generated from PanelWindow.vala, do not modify */

/*
 * Copyright 2024 elementary, Inc. (https://elementary.io)
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 * Authored by: Leonhard Kargl <leo.kargl@proton.me>
 */

#include <glib-object.h>
#include <meta/common.h>
#include "gala.h"
#include <meta/window.h>
#include <glib.h>
#include <meta/boxes.h>
#include <mtk/mtk.h>
#include "pantheon-desktop-shell-server-protocol.h"
#include <meta/display.h>
#include <meta/meta-plugin.h>
#include <string.h>
#include <meta/meta-workspace-manager.h>
#include <meta/workspace.h>
#include <float.h>
#include <math.h>
#include <meta/meta-context.h>
#include <meta/meta-backend.h>
#include <meta/barrier.h>
#include <meta/meta-monitor-manager.h>

#define GALA_PANEL_WINDOW_BARRIER_OFFSET 50
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_PANEL_WINDOW (gala_panel_window_get_type ())
#define GALA_PANEL_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_PANEL_WINDOW, GalaPanelWindow))
#define GALA_PANEL_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_PANEL_WINDOW, GalaPanelWindowClass))
#define GALA_IS_PANEL_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_PANEL_WINDOW))
#define GALA_IS_PANEL_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_PANEL_WINDOW))
#define GALA_PANEL_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_PANEL_WINDOW, GalaPanelWindowClass))

typedef struct _GalaPanelWindow GalaPanelWindow;
typedef struct _GalaPanelWindowClass GalaPanelWindowClass;
typedef struct _GalaPanelWindowPrivate GalaPanelWindowPrivate;

#define GALA_TYPE_BARRIER (gala_barrier_get_type ())
#define GALA_BARRIER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_BARRIER, GalaBarrier))
#define GALA_BARRIER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_BARRIER, GalaBarrierClass))
#define GALA_IS_BARRIER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_BARRIER))
#define GALA_IS_BARRIER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_BARRIER))
#define GALA_BARRIER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_BARRIER, GalaBarrierClass))

typedef struct _GalaBarrier GalaBarrier;
typedef struct _GalaBarrierClass GalaBarrierClass;

#define GALA_TYPE_PANEL_CLONE (gala_panel_clone_get_type ())
#define GALA_PANEL_CLONE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_PANEL_CLONE, GalaPanelClone))
#define GALA_PANEL_CLONE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_PANEL_CLONE, GalaPanelCloneClass))
#define GALA_IS_PANEL_CLONE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_PANEL_CLONE))
#define GALA_IS_PANEL_CLONE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_PANEL_CLONE))
#define GALA_PANEL_CLONE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_PANEL_CLONE, GalaPanelCloneClass))

typedef struct _GalaPanelClone GalaPanelClone;
typedef struct _GalaPanelCloneClass GalaPanelCloneClass;
enum  {
	GALA_PANEL_WINDOW_0_PROPERTY,
	GALA_PANEL_WINDOW_WM_PROPERTY,
	GALA_PANEL_WINDOW_WINDOW_PROPERTY,
	GALA_PANEL_WINDOW_HIDDEN_PROPERTY,
	GALA_PANEL_WINDOW_NUM_PROPERTIES
};
static GParamSpec* gala_panel_window_properties[GALA_PANEL_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block62Data Block62Data;

struct _GalaPanelWindow {
	GObject parent_instance;
	GalaPanelWindowPrivate * priv;
	MetaSide anchor;
};

struct _GalaPanelWindowClass {
	GObjectClass parent_class;
};

struct _GalaPanelWindowPrivate {
	GalaWindowManager* _wm;
	MetaWindow* _window;
	gboolean _hidden;
	GalaBarrier* barrier;
	GalaPanelClone* clone;
	guint idle_move_id;
	gint width;
	gint height;
};

struct _Block62Data {
	int _ref_count_;
	GalaPanelWindow* self;
	gint x;
	gint y;
};

static gint GalaPanelWindow_private_offset;
static gpointer gala_panel_window_parent_class = NULL;
static GHashTable* gala_panel_window_window_struts;
static GHashTable* gala_panel_window_window_struts = NULL;

VALA_EXTERN GType gala_panel_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaPanelWindow, g_object_unref)
VALA_EXTERN GType gala_barrier_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaBarrier, g_object_unref)
VALA_EXTERN GType gala_panel_clone_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaPanelClone, g_object_unref)
static void _g_object_unref0_ (gpointer var);
static void _g_free0_ (gpointer var);
VALA_EXTERN GalaPanelWindow* gala_panel_window_new (GalaWindowManager* wm,
                                        MetaWindow* window,
                                        MetaSide anchor);
VALA_EXTERN GalaPanelWindow* gala_panel_window_construct (GType object_type,
                                              GalaWindowManager* wm,
                                              MetaWindow* window,
                                              MetaSide anchor);
VALA_EXTERN void gala_panel_window_get_custom_window_rect (GalaPanelWindow* self,
                                               MtkRectangle* result);
VALA_EXTERN MetaWindow* gala_panel_window_get_window (GalaPanelWindow* self);
VALA_EXTERN void gala_panel_window_set_size (GalaPanelWindow* self,
                                 gint width,
                                 gint height);
static void gala_panel_window_position_window (GalaPanelWindow* self);
VALA_EXTERN void gala_panel_window_set_hide_mode (GalaPanelWindow* self,
                                      enum io_elementary_pantheon_panel_v1_hide_mode hide_mode);
VALA_EXTERN enum io_elementary_pantheon_panel_v1_hide_mode gala_panel_clone_get_hide_mode (GalaPanelClone* self);
VALA_EXTERN void gala_panel_window_update_anchor (GalaPanelWindow* self,
                                      MetaSide anchor);
VALA_EXTERN GalaWindowManager* gala_panel_window_get_wm (GalaPanelWindow* self);
static void gala_panel_window_position_window_top (GalaPanelWindow* self,
                                            MtkRectangle* monitor_geom,
                                            MtkRectangle* window_rect);
static void gala_panel_window_position_window_bottom (GalaPanelWindow* self,
                                               MtkRectangle* monitor_geom,
                                               MtkRectangle* window_rect);
static void gala_panel_window_update_strut (GalaPanelWindow* self);
static void gala_panel_window_move_window_idle (GalaPanelWindow* self,
                                         gint x,
                                         gint y);
static Block62Data* block62_data_ref (Block62Data* _data62_);
static void block62_data_unref (void * _userdata_);
static gboolean __lambda111_ (Block62Data* _data62_);
static gboolean ___lambda111__gsource_func (gpointer self);
VALA_EXTERN void gala_panel_clone_set_hide_mode (GalaPanelClone* self,
                                     enum io_elementary_pantheon_panel_v1_hide_mode value);
static void gala_panel_window_destroy_barrier (GalaPanelWindow* self);
static void gala_panel_window_make_exclusive (GalaPanelWindow* self);
static void gala_panel_window_unmake_exclusive (GalaPanelWindow* self);
static void gala_panel_window_setup_barrier (GalaPanelWindow* self);
static MetaStrut* _meta_strut_dup (MetaStrut* self);
static void gala_panel_window_update_struts (GalaPanelWindow* self);
static inline void _g_slist_free__g_free0_ (GSList* self);
VALA_EXTERN gint gala_internal_utils_scale_to_int (gint value,
                                       gfloat scale_factor);
static void gala_panel_window_setup_barrier_top (GalaPanelWindow* self,
                                          MtkRectangle* monitor_geom,
                                          gint offset);
static void gala_panel_window_setup_barrier_bottom (GalaPanelWindow* self,
                                             MtkRectangle* monitor_geom,
                                             gint offset);
VALA_EXTERN GalaBarrier* gala_barrier_new (MetaBackend* backend,
                               gint x1,
                               gint y1,
                               gint x2,
                               gint y2,
                               MetaBarrierDirection directions,
                               gint trigger_pressure_threshold,
                               gint release_pressure_threshold,
                               gint retrigger_pressure_threshold,
                               gint retrigger_delay);
VALA_EXTERN GalaBarrier* gala_barrier_construct (GType object_type,
                                     MetaBackend* backend,
                                     gint x1,
                                     gint y1,
                                     gint x2,
                                     gint y2,
                                     MetaBarrierDirection directions,
                                     gint trigger_pressure_threshold,
                                     gint release_pressure_threshold,
                                     gint retrigger_pressure_threshold,
                                     gint retrigger_delay);
VALA_EXTERN void gala_panel_clone_show (GalaPanelClone* self);
static void _gala_panel_clone_show_gala_barrier_trigger (GalaBarrier* _sender,
                                                  gpointer self);
static void gala_panel_window_set_wm (GalaPanelWindow* self,
                               GalaWindowManager* value);
static void gala_panel_window_set_window (GalaPanelWindow* self,
                                   MetaWindow* value);
VALA_EXTERN gboolean gala_panel_window_get_hidden (GalaPanelWindow* self);
static void gala_panel_window_set_hidden (GalaPanelWindow* self,
                                   gboolean value);
static GObject * gala_panel_window_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static void _gala_panel_window_position_window_meta_window_size_changed (MetaWindow* _sender,
                                                                  gpointer self);
static void _gala_panel_window___lambda112_ (GalaPanelWindow* self);
static void __gala_panel_window___lambda112__meta_window_unmanaging (MetaWindow* _sender,
                                                              gpointer self);
VALA_EXTERN GalaPanelClone* gala_panel_clone_new (GalaWindowManager* wm,
                                      GalaPanelWindow* panel);
VALA_EXTERN GalaPanelClone* gala_panel_clone_construct (GType object_type,
                                            GalaWindowManager* wm,
                                            GalaPanelWindow* panel);
static void _gala_panel_window___lambda113_ (GalaPanelWindow* self);
static void __gala_panel_window___lambda113__meta_monitor_manager_monitors_changed (MetaMonitorManager* _sender,
                                                                             gpointer self);
static void _gala_panel_window___lambda114_ (GalaPanelWindow* self);
static void __gala_panel_window___lambda114__meta_monitor_manager_monitors_changed_internal (MetaMonitorManager* _sender,
                                                                                      gpointer self);
static void _gala_panel_window_update_strut_meta_workspace_manager_workspace_added (MetaWorkspaceManager* _sender,
                                                                             gint object,
                                                                             gpointer self);
static void _gala_panel_window_update_strut_meta_workspace_manager_workspace_removed (MetaWorkspaceManager* _sender,
                                                                               gint object,
                                                                               gpointer self);
static void gala_panel_window_finalize (GObject * obj);
static GType gala_panel_window_get_type_once (void);
static void _vala_gala_panel_window_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_gala_panel_window_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);

static inline gpointer
gala_panel_window_get_instance_private (GalaPanelWindow* self)
{
	return G_STRUCT_MEMBER_P (self, GalaPanelWindow_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static void
_g_free0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_free (var), NULL));
}

GalaPanelWindow*
gala_panel_window_construct (GType object_type,
                             GalaWindowManager* wm,
                             MetaWindow* window,
                             MetaSide anchor)
{
	GalaPanelWindow * self = NULL;
	g_return_val_if_fail (wm != NULL, NULL);
	g_return_val_if_fail (window != NULL, NULL);
	self = (GalaPanelWindow*) g_object_new (object_type, "wm", wm, "window", window, NULL);
	self->anchor = anchor;
	return self;
}

GalaPanelWindow*
gala_panel_window_new (GalaWindowManager* wm,
                       MetaWindow* window,
                       MetaSide anchor)
{
	return gala_panel_window_construct (GALA_TYPE_PANEL_WINDOW, wm, window, anchor);
}

void
gala_panel_window_get_custom_window_rect (GalaPanelWindow* self,
                                          MtkRectangle* result)
{
	MtkRectangle window_rect = {0};
	MetaWindow* _tmp0_;
	MtkRectangle _tmp1_ = {0};
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_window;
	meta_window_get_frame_rect (_tmp0_, &_tmp1_);
	window_rect = _tmp1_;
	if (self->priv->width > 0) {
		window_rect.width = self->priv->width;
	}
	if (self->priv->height > 0) {
		window_rect.height = self->priv->height;
	}
	*result = window_rect;
	return;
}

void
gala_panel_window_set_size (GalaPanelWindow* self,
                            gint width,
                            gint height)
{
	GalaPanelClone* _tmp0_;
	enum io_elementary_pantheon_panel_v1_hide_mode _tmp1_;
	enum io_elementary_pantheon_panel_v1_hide_mode _tmp2_;
	g_return_if_fail (self != NULL);
	self->priv->width = width;
	self->priv->height = height;
	gala_panel_window_position_window (self);
	_tmp0_ = self->priv->clone;
	_tmp1_ = gala_panel_clone_get_hide_mode (_tmp0_);
	_tmp2_ = _tmp1_;
	gala_panel_window_set_hide_mode (self, _tmp2_);
}

void
gala_panel_window_update_anchor (GalaPanelWindow* self,
                                 MetaSide anchor)
{
	GalaPanelClone* _tmp0_;
	enum io_elementary_pantheon_panel_v1_hide_mode _tmp1_;
	enum io_elementary_pantheon_panel_v1_hide_mode _tmp2_;
	g_return_if_fail (self != NULL);
	self->anchor = anchor;
	gala_panel_window_position_window (self);
	_tmp0_ = self->priv->clone;
	_tmp1_ = gala_panel_clone_get_hide_mode (_tmp0_);
	_tmp2_ = _tmp1_;
	gala_panel_window_set_hide_mode (self, _tmp2_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
gala_panel_window_position_window (GalaPanelWindow* self)
{
	MetaDisplay* display = NULL;
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
	MetaDisplay* _tmp2_;
	MtkRectangle monitor_geom = {0};
	MetaDisplay* _tmp3_;
	MetaDisplay* _tmp4_;
	MtkRectangle _tmp5_ = {0};
	MtkRectangle window_rect = {0};
	MtkRectangle _tmp6_ = {0};
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_wm;
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	display = _tmp2_;
	_tmp3_ = display;
	_tmp4_ = display;
	meta_display_get_monitor_geometry (_tmp3_, meta_display_get_primary_monitor (_tmp4_), &_tmp5_);
	monitor_geom = _tmp5_;
	gala_panel_window_get_custom_window_rect (self, &_tmp6_);
	window_rect = _tmp6_;
	switch (self->anchor) {
		case META_SIDE_TOP:
		{
			MtkRectangle _tmp7_;
			MtkRectangle _tmp8_;
			_tmp7_ = monitor_geom;
			_tmp8_ = window_rect;
			gala_panel_window_position_window_top (self, &_tmp7_, &_tmp8_);
			break;
		}
		case META_SIDE_BOTTOM:
		{
			MtkRectangle _tmp9_;
			MtkRectangle _tmp10_;
			_tmp9_ = monitor_geom;
			_tmp10_ = window_rect;
			gala_panel_window_position_window_bottom (self, &_tmp9_, &_tmp10_);
			break;
		}
		default:
		{
			g_warning ("PanelWindow.vala:113: Side not supported yet");
			break;
		}
	}
	gala_panel_window_update_strut (self);
	_g_object_unref0 (display);
}

static void
gala_panel_window_position_window_top (GalaPanelWindow* self,
                                       MtkRectangle* monitor_geom,
                                       MtkRectangle* window_rect)
{
	gint x = 0;
	MtkRectangle _tmp0_;
	MtkRectangle _tmp1_;
	MtkRectangle _tmp2_;
	MtkRectangle _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (monitor_geom != NULL);
	g_return_if_fail (window_rect != NULL);
	_tmp0_ = *monitor_geom;
	_tmp1_ = *monitor_geom;
	_tmp2_ = *window_rect;
	x = _tmp0_.x + ((_tmp1_.width - _tmp2_.width) / 2);
	_tmp3_ = *monitor_geom;
	gala_panel_window_move_window_idle (self, x, _tmp3_.y);
}

static void
gala_panel_window_position_window_bottom (GalaPanelWindow* self,
                                          MtkRectangle* monitor_geom,
                                          MtkRectangle* window_rect)
{
	gint x = 0;
	MtkRectangle _tmp0_;
	MtkRectangle _tmp1_;
	MtkRectangle _tmp2_;
	gint y = 0;
	MtkRectangle _tmp3_;
	MtkRectangle _tmp4_;
	MtkRectangle _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (monitor_geom != NULL);
	g_return_if_fail (window_rect != NULL);
	_tmp0_ = *monitor_geom;
	_tmp1_ = *monitor_geom;
	_tmp2_ = *window_rect;
	x = _tmp0_.x + ((_tmp1_.width - _tmp2_.width) / 2);
	_tmp3_ = *monitor_geom;
	_tmp4_ = *monitor_geom;
	_tmp5_ = *window_rect;
	y = (_tmp3_.y + _tmp4_.height) - _tmp5_.height;
	gala_panel_window_move_window_idle (self, x, y);
}

static Block62Data*
block62_data_ref (Block62Data* _data62_)
{
	g_atomic_int_inc (&_data62_->_ref_count_);
	return _data62_;
}

static void
block62_data_unref (void * _userdata_)
{
	Block62Data* _data62_;
	_data62_ = (Block62Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data62_->_ref_count_)) {
		GalaPanelWindow* self;
		self = _data62_->self;
		_g_object_unref0 (self);
		g_slice_free (Block62Data, _data62_);
	}
}

static gboolean
__lambda111_ (Block62Data* _data62_)
{
	GalaPanelWindow* self;
	MetaWindow* _tmp0_;
	gboolean result;
	self = _data62_->self;
	_tmp0_ = self->priv->_window;
	meta_window_move_frame (_tmp0_, FALSE, _data62_->x, _data62_->y);
	self->priv->idle_move_id = (guint) 0;
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
___lambda111__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda111_ (self);
	return result;
}

static void
gala_panel_window_move_window_idle (GalaPanelWindow* self,
                                    gint x,
                                    gint y)
{
	Block62Data* _data62_;
	g_return_if_fail (self != NULL);
	_data62_ = g_slice_new0 (Block62Data);
	_data62_->_ref_count_ = 1;
	_data62_->self = g_object_ref (self);
	_data62_->x = x;
	_data62_->y = y;
	if (self->priv->idle_move_id != ((guint) 0)) {
		g_source_remove (self->priv->idle_move_id);
	}
	self->priv->idle_move_id = g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda111__gsource_func, block62_data_ref (_data62_), block62_data_unref);
	block62_data_unref (_data62_);
	_data62_ = NULL;
}

void
gala_panel_window_set_hide_mode (GalaPanelWindow* self,
                                 enum io_elementary_pantheon_panel_v1_hide_mode hide_mode)
{
	GalaPanelClone* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->clone;
	gala_panel_clone_set_hide_mode (_tmp0_, hide_mode);
	gala_panel_window_destroy_barrier (self);
	if (hide_mode == IO_ELEMENTARY_PANTHEON_PANEL_V1_HIDE_MODE_NEVER) {
		gala_panel_window_make_exclusive (self);
	} else {
		gala_panel_window_unmake_exclusive (self);
		gala_panel_window_setup_barrier (self);
	}
}

static void
gala_panel_window_make_exclusive (GalaPanelWindow* self)
{
	g_return_if_fail (self != NULL);
	gala_panel_window_update_strut (self);
}

static MetaStrut*
_meta_strut_dup (MetaStrut* self)
{
	MetaStrut* dup;
	dup = g_new0 (MetaStrut, 1);
	memcpy (dup, self, sizeof (MetaStrut));
	return dup;
}

static gpointer
__meta_strut_dup0 (gpointer self)
{
	return self ? _meta_strut_dup (self) : NULL;
}

static void
gala_panel_window_update_strut (GalaPanelWindow* self)
{
	GalaPanelClone* _tmp0_;
	enum io_elementary_pantheon_panel_v1_hide_mode _tmp1_;
	enum io_elementary_pantheon_panel_v1_hide_mode _tmp2_;
	MtkRectangle rect = {0};
	MtkRectangle _tmp3_ = {0};
	MetaStrut strut = {0};
	MtkRectangle _tmp4_;
	MetaStrut _tmp5_ = {0};
	GHashTable* _tmp6_;
	MetaWindow* _tmp7_;
	MetaWindow* _tmp8_;
	MetaStrut _tmp9_;
	MetaStrut* _tmp10_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->clone;
	_tmp1_ = gala_panel_clone_get_hide_mode (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ != IO_ELEMENTARY_PANTHEON_PANEL_V1_HIDE_MODE_NEVER) {
		return;
	}
	gala_panel_window_get_custom_window_rect (self, &_tmp3_);
	rect = _tmp3_;
	_tmp4_ = rect;
	_tmp5_.rect = _tmp4_;
	_tmp5_.side = self->anchor;
	strut = _tmp5_;
	_tmp6_ = gala_panel_window_window_struts;
	_tmp7_ = self->priv->_window;
	_tmp8_ = _g_object_ref0 (_tmp7_);
	_tmp9_ = strut;
	_tmp10_ = __meta_strut_dup0 (&_tmp9_);
	g_hash_table_insert (_tmp6_, _tmp8_, _tmp10_);
	gala_panel_window_update_struts (self);
}

static inline void
_g_slist_free__g_free0_ (GSList* self)
{
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
}

static void
gala_panel_window_update_struts (GalaPanelWindow* self)
{
	GSList* list = NULL;
	GHashTable* _tmp0_;
	GList* _tmp1_;
	GalaWindowManager* _tmp4_;
	MetaDisplay* _tmp5_;
	MetaWorkspaceManager* _tmp6_;
	GList* _tmp7_;
	g_return_if_fail (self != NULL);
	list = NULL;
	_tmp0_ = gala_panel_window_window_struts;
	_tmp1_ = g_hash_table_get_values (_tmp0_);
	{
		GList* window_strut_collection = NULL;
		GList* window_strut_it = NULL;
		window_strut_collection = _tmp1_;
		for (window_strut_it = window_strut_collection; window_strut_it != NULL; window_strut_it = window_strut_it->next) {
			MetaStrut* window_strut = NULL;
			window_strut = (MetaStrut*) window_strut_it->data;
			{
				MetaStrut* _tmp2_;
				MetaStrut* _tmp3_;
				_tmp2_ = window_strut;
				_tmp3_ = __meta_strut_dup0 (_tmp2_);
				list = g_slist_append (list, _tmp3_);
			}
		}
		(window_strut_collection == NULL) ? NULL : (window_strut_collection = (g_list_free (window_strut_collection), NULL));
	}
	_tmp4_ = self->priv->_wm;
	_tmp5_ = meta_plugin_get_display ((MetaPlugin*) _tmp4_);
	_tmp6_ = meta_display_get_workspace_manager (_tmp5_);
	_tmp7_ = meta_workspace_manager_get_workspaces (_tmp6_);
	{
		GList* workspace_collection = NULL;
		GList* workspace_it = NULL;
		workspace_collection = _tmp7_;
		for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
			MetaWorkspace* _tmp8_;
			MetaWorkspace* workspace = NULL;
			_tmp8_ = _g_object_ref0 ((MetaWorkspace*) workspace_it->data);
			workspace = _tmp8_;
			{
				MetaWorkspace* _tmp9_;
				GSList* _tmp10_;
				_tmp9_ = workspace;
				_tmp10_ = list;
				meta_workspace_set_builtin_struts (_tmp9_, _tmp10_);
				_g_object_unref0 (workspace);
			}
		}
	}
	(list == NULL) ? NULL : (list = (_g_slist_free__g_free0_ (list), NULL));
}

static void
gala_panel_window_unmake_exclusive (GalaPanelWindow* self)
{
	GHashTable* _tmp0_;
	MetaWindow* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gala_panel_window_window_struts;
	_tmp1_ = self->priv->_window;
	if (g_hash_table_contains (_tmp0_, _tmp1_)) {
		GHashTable* _tmp2_;
		MetaWindow* _tmp3_;
		_tmp2_ = gala_panel_window_window_struts;
		_tmp3_ = self->priv->_window;
		g_hash_table_remove (_tmp2_, _tmp3_);
		gala_panel_window_update_struts (self);
	}
}

static void
gala_panel_window_destroy_barrier (GalaPanelWindow* self)
{
	g_return_if_fail (self != NULL);
	_g_object_unref0 (self->priv->barrier);
	self->priv->barrier = NULL;
}

static void
gala_panel_window_setup_barrier (GalaPanelWindow* self)
{
	MetaDisplay* display = NULL;
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
	MetaDisplay* _tmp2_;
	MtkRectangle monitor_geom = {0};
	MetaDisplay* _tmp3_;
	MetaDisplay* _tmp4_;
	MtkRectangle _tmp5_ = {0};
	gfloat scale = 0.0F;
	MetaDisplay* _tmp6_;
	MetaDisplay* _tmp7_;
	gint offset = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_wm;
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	display = _tmp2_;
	_tmp3_ = display;
	_tmp4_ = display;
	meta_display_get_monitor_geometry (_tmp3_, meta_display_get_primary_monitor (_tmp4_), &_tmp5_);
	monitor_geom = _tmp5_;
	_tmp6_ = display;
	_tmp7_ = display;
	scale = meta_display_get_monitor_scale (_tmp6_, meta_display_get_primary_monitor (_tmp7_));
	offset = gala_internal_utils_scale_to_int (GALA_PANEL_WINDOW_BARRIER_OFFSET, scale);
	switch (self->anchor) {
		case META_SIDE_TOP:
		{
			MtkRectangle _tmp8_;
			_tmp8_ = monitor_geom;
			gala_panel_window_setup_barrier_top (self, &_tmp8_, offset);
			break;
		}
		case META_SIDE_BOTTOM:
		{
			MtkRectangle _tmp9_;
			_tmp9_ = monitor_geom;
			gala_panel_window_setup_barrier_bottom (self, &_tmp9_, offset);
			break;
		}
		default:
		{
			g_warning ("PanelWindow.vala:227: Barrier side not supported yet");
			break;
		}
	}
	_g_object_unref0 (display);
}

static void
_gala_panel_clone_show_gala_barrier_trigger (GalaBarrier* _sender,
                                             gpointer self)
{
	gala_panel_clone_show ((GalaPanelClone*) self);
}

static void
gala_panel_window_setup_barrier_top (GalaPanelWindow* self,
                                     MtkRectangle* monitor_geom,
                                     gint offset)
{
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
	MetaContext* _tmp2_;
	MetaBackend* _tmp3_;
	MtkRectangle _tmp4_;
	MtkRectangle _tmp5_;
	MtkRectangle _tmp6_;
	MtkRectangle _tmp7_;
	MtkRectangle _tmp8_;
	GalaBarrier* _tmp9_;
	GalaBarrier* _tmp10_;
	GalaPanelClone* _tmp11_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (monitor_geom != NULL);
	_tmp0_ = self->priv->_wm;
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
	_tmp2_ = meta_display_get_context (_tmp1_);
	_tmp3_ = meta_context_get_backend (_tmp2_);
	_tmp4_ = *monitor_geom;
	_tmp5_ = *monitor_geom;
	_tmp6_ = *monitor_geom;
	_tmp7_ = *monitor_geom;
	_tmp8_ = *monitor_geom;
	_tmp9_ = gala_barrier_new (_tmp3_, _tmp4_.x + offset, _tmp5_.y, (_tmp6_.x + _tmp7_.width) - offset, _tmp8_.y, META_BARRIER_DIRECTION_POSITIVE_Y, 0, 0, G_MAXINT, G_MAXINT);
	_g_object_unref0 (self->priv->barrier);
	self->priv->barrier = _tmp9_;
	_tmp10_ = self->priv->barrier;
	_tmp11_ = self->priv->clone;
	g_signal_connect_object (_tmp10_, "trigger", (GCallback) _gala_panel_clone_show_gala_barrier_trigger, _tmp11_, 0);
}

static void
gala_panel_window_setup_barrier_bottom (GalaPanelWindow* self,
                                        MtkRectangle* monitor_geom,
                                        gint offset)
{
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
	MetaContext* _tmp2_;
	MetaBackend* _tmp3_;
	MtkRectangle _tmp4_;
	MtkRectangle _tmp5_;
	MtkRectangle _tmp6_;
	MtkRectangle _tmp7_;
	MtkRectangle _tmp8_;
	MtkRectangle _tmp9_;
	MtkRectangle _tmp10_;
	GalaBarrier* _tmp11_;
	GalaBarrier* _tmp12_;
	GalaPanelClone* _tmp13_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (monitor_geom != NULL);
	_tmp0_ = self->priv->_wm;
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
	_tmp2_ = meta_display_get_context (_tmp1_);
	_tmp3_ = meta_context_get_backend (_tmp2_);
	_tmp4_ = *monitor_geom;
	_tmp5_ = *monitor_geom;
	_tmp6_ = *monitor_geom;
	_tmp7_ = *monitor_geom;
	_tmp8_ = *monitor_geom;
	_tmp9_ = *monitor_geom;
	_tmp10_ = *monitor_geom;
	_tmp11_ = gala_barrier_new (_tmp3_, _tmp4_.x + offset, _tmp5_.y + _tmp6_.height, (_tmp7_.x + _tmp8_.width) - offset, _tmp9_.y + _tmp10_.height, META_BARRIER_DIRECTION_NEGATIVE_Y, 0, 0, G_MAXINT, G_MAXINT);
	_g_object_unref0 (self->priv->barrier);
	self->priv->barrier = _tmp11_;
	_tmp12_ = self->priv->barrier;
	_tmp13_ = self->priv->clone;
	g_signal_connect_object (_tmp12_, "trigger", (GCallback) _gala_panel_clone_show_gala_barrier_trigger, _tmp13_, 0);
}

GalaWindowManager*
gala_panel_window_get_wm (GalaPanelWindow* self)
{
	GalaWindowManager* result;
	GalaWindowManager* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_wm;
	result = _tmp0_;
	return result;
}

static void
gala_panel_window_set_wm (GalaPanelWindow* self,
                          GalaWindowManager* value)
{
	GalaWindowManager* old_value;
	g_return_if_fail (self != NULL);
	old_value = gala_panel_window_get_wm (self);
	if (old_value != value) {
		GalaWindowManager* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_wm);
		self->priv->_wm = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gala_panel_window_properties[GALA_PANEL_WINDOW_WM_PROPERTY]);
	}
}

MetaWindow*
gala_panel_window_get_window (GalaPanelWindow* self)
{
	MetaWindow* result;
	MetaWindow* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_window;
	result = _tmp0_;
	return result;
}

static void
gala_panel_window_set_window (GalaPanelWindow* self,
                              MetaWindow* value)
{
	MetaWindow* old_value;
	g_return_if_fail (self != NULL);
	old_value = gala_panel_window_get_window (self);
	if (old_value != value) {
		MetaWindow* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_window);
		self->priv->_window = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gala_panel_window_properties[GALA_PANEL_WINDOW_WINDOW_PROPERTY]);
	}
}

gboolean
gala_panel_window_get_hidden (GalaPanelWindow* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_hidden;
	return result;
}

static void
gala_panel_window_set_hidden (GalaPanelWindow* self,
                              gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = gala_panel_window_get_hidden (self);
	if (old_value != value) {
		self->priv->_hidden = value;
		g_object_notify_by_pspec ((GObject *) self, gala_panel_window_properties[GALA_PANEL_WINDOW_HIDDEN_PROPERTY]);
	}
}

static void
_gala_panel_window_position_window_meta_window_size_changed (MetaWindow* _sender,
                                                             gpointer self)
{
	gala_panel_window_position_window ((GalaPanelWindow*) self);
}

static void
_gala_panel_window___lambda112_ (GalaPanelWindow* self)
{
	GHashTable* _tmp0_;
	MetaWindow* _tmp1_;
	if (self->priv->idle_move_id != ((guint) 0)) {
		g_source_remove (self->priv->idle_move_id);
	}
	gala_panel_window_destroy_barrier (self);
	_tmp0_ = gala_panel_window_window_struts;
	_tmp1_ = self->priv->_window;
	if (g_hash_table_remove (_tmp0_, _tmp1_)) {
		gala_panel_window_update_struts (self);
	}
}

static void
__gala_panel_window___lambda112__meta_window_unmanaging (MetaWindow* _sender,
                                                         gpointer self)
{
	_gala_panel_window___lambda112_ ((GalaPanelWindow*) self);
}

static void
_gala_panel_window___lambda113_ (GalaPanelWindow* self)
{
	gala_panel_window_update_anchor (self, self->anchor);
}

static void
__gala_panel_window___lambda113__meta_monitor_manager_monitors_changed (MetaMonitorManager* _sender,
                                                                        gpointer self)
{
	_gala_panel_window___lambda113_ ((GalaPanelWindow*) self);
}

static void
_gala_panel_window___lambda114_ (GalaPanelWindow* self)
{
	gala_panel_window_update_anchor (self, self->anchor);
}

static void
__gala_panel_window___lambda114__meta_monitor_manager_monitors_changed_internal (MetaMonitorManager* _sender,
                                                                                 gpointer self)
{
	_gala_panel_window___lambda114_ ((GalaPanelWindow*) self);
}

static void
_gala_panel_window_update_strut_meta_workspace_manager_workspace_added (MetaWorkspaceManager* _sender,
                                                                        gint object,
                                                                        gpointer self)
{
	gala_panel_window_update_strut ((GalaPanelWindow*) self);
}

static void
_gala_panel_window_update_strut_meta_workspace_manager_workspace_removed (MetaWorkspaceManager* _sender,
                                                                          gint object,
                                                                          gpointer self)
{
	gala_panel_window_update_strut ((GalaPanelWindow*) self);
}

static GObject *
gala_panel_window_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaPanelWindow * self;
	MetaWindow* _tmp0_;
	MetaWindow* _tmp1_;
	MetaWindow* _tmp2_;
	GalaWindowManager* _tmp3_;
	GalaPanelClone* _tmp4_;
	MetaMonitorManager* monitor_manager = NULL;
	GalaWindowManager* _tmp5_;
	MetaDisplay* _tmp6_;
	MetaContext* _tmp7_;
	MetaBackend* _tmp8_;
	MetaMonitorManager* _tmp9_;
	MetaMonitorManager* _tmp10_;
	MetaMonitorManager* _tmp11_;
	MetaMonitorManager* _tmp12_;
	MetaWorkspaceManager* workspace_manager = NULL;
	GalaWindowManager* _tmp13_;
	MetaDisplay* _tmp14_;
	MetaWorkspaceManager* _tmp15_;
	MetaWorkspaceManager* _tmp16_;
	MetaWorkspaceManager* _tmp17_;
	MetaWorkspaceManager* _tmp18_;
	parent_class = G_OBJECT_CLASS (gala_panel_window_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_PANEL_WINDOW, GalaPanelWindow);
	_tmp0_ = self->priv->_window;
	g_signal_connect_object (_tmp0_, "size-changed", (GCallback) _gala_panel_window_position_window_meta_window_size_changed, self, 0);
	_tmp1_ = self->priv->_window;
	g_signal_connect_object (_tmp1_, "unmanaging", (GCallback) __gala_panel_window___lambda112__meta_window_unmanaging, self, 0);
	_tmp2_ = self->priv->_window;
	meta_window_stick (_tmp2_);
	_tmp3_ = self->priv->_wm;
	_tmp4_ = gala_panel_clone_new (_tmp3_, self);
	_g_object_unref0 (self->priv->clone);
	self->priv->clone = _tmp4_;
	_tmp5_ = self->priv->_wm;
	_tmp6_ = meta_plugin_get_display ((MetaPlugin*) _tmp5_);
	_tmp7_ = meta_display_get_context (_tmp6_);
	_tmp8_ = meta_context_get_backend (_tmp7_);
	_tmp9_ = meta_backend_get_monitor_manager (_tmp8_);
	_tmp10_ = _g_object_ref0 (_tmp9_);
	monitor_manager = _tmp10_;
	_tmp11_ = monitor_manager;
	g_signal_connect_object (_tmp11_, "monitors-changed", (GCallback) __gala_panel_window___lambda113__meta_monitor_manager_monitors_changed, self, 0);
	_tmp12_ = monitor_manager;
	g_signal_connect_object (_tmp12_, "monitors-changed-internal", (GCallback) __gala_panel_window___lambda114__meta_monitor_manager_monitors_changed_internal, self, 0);
	_tmp13_ = self->priv->_wm;
	_tmp14_ = meta_plugin_get_display ((MetaPlugin*) _tmp13_);
	_tmp15_ = meta_display_get_workspace_manager (_tmp14_);
	_tmp16_ = _g_object_ref0 (_tmp15_);
	workspace_manager = _tmp16_;
	_tmp17_ = workspace_manager;
	g_signal_connect_object (_tmp17_, "workspace-added", (GCallback) _gala_panel_window_update_strut_meta_workspace_manager_workspace_added, self, 0);
	_tmp18_ = workspace_manager;
	g_signal_connect_object (_tmp18_, "workspace-removed", (GCallback) _gala_panel_window_update_strut_meta_workspace_manager_workspace_removed, self, 0);
	_g_object_unref0 (workspace_manager);
	_g_object_unref0 (monitor_manager);
	return obj;
}

static void
gala_panel_window_class_init (GalaPanelWindowClass * klass,
                              gpointer klass_data)
{
	GHashTable* _tmp0_;
	gala_panel_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GalaPanelWindow_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_panel_window_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_panel_window_set_property;
	G_OBJECT_CLASS (klass)->constructor = gala_panel_window_constructor;
	G_OBJECT_CLASS (klass)->finalize = gala_panel_window_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_PANEL_WINDOW_WM_PROPERTY, gala_panel_window_properties[GALA_PANEL_WINDOW_WM_PROPERTY] = g_param_spec_object ("wm", "wm", "wm", GALA_TYPE_WINDOW_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_PANEL_WINDOW_WINDOW_PROPERTY, gala_panel_window_properties[GALA_PANEL_WINDOW_WINDOW_PROPERTY] = g_param_spec_object ("window", "window", "window", meta_window_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_PANEL_WINDOW_HIDDEN_PROPERTY, gala_panel_window_properties[GALA_PANEL_WINDOW_HIDDEN_PROPERTY] = g_param_spec_boolean ("hidden", "hidden", "hidden", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	_tmp0_ = g_hash_table_new_full (NULL, NULL, _g_object_unref0_, _g_free0_);
	gala_panel_window_window_struts = _tmp0_;
}

static void
gala_panel_window_instance_init (GalaPanelWindow * self,
                                 gpointer klass)
{
	self->priv = gala_panel_window_get_instance_private (self);
	self->priv->_hidden = FALSE;
	self->priv->idle_move_id = (guint) 0;
	self->priv->width = -1;
	self->priv->height = -1;
}

static void
gala_panel_window_finalize (GObject * obj)
{
	GalaPanelWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_PANEL_WINDOW, GalaPanelWindow);
	_g_object_unref0 (self->priv->_wm);
	_g_object_unref0 (self->priv->_window);
	_g_object_unref0 (self->priv->barrier);
	_g_object_unref0 (self->priv->clone);
	G_OBJECT_CLASS (gala_panel_window_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
gala_panel_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaPanelWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_panel_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaPanelWindow), 0, (GInstanceInitFunc) gala_panel_window_instance_init, NULL };
	GType gala_panel_window_type_id;
	gala_panel_window_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaPanelWindow", &g_define_type_info, 0);
	GalaPanelWindow_private_offset = g_type_add_instance_private (gala_panel_window_type_id, sizeof (GalaPanelWindowPrivate));
	return gala_panel_window_type_id;
}

GType
gala_panel_window_get_type (void)
{
	static gsize gala_panel_window_type_id__once = 0;
	if (g_once_init_enter (&gala_panel_window_type_id__once)) {
		GType gala_panel_window_type_id;
		gala_panel_window_type_id = gala_panel_window_get_type_once ();
		g_once_init_leave (&gala_panel_window_type_id__once, gala_panel_window_type_id);
	}
	return gala_panel_window_type_id__once;
}

static void
_vala_gala_panel_window_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	GalaPanelWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_PANEL_WINDOW, GalaPanelWindow);
	switch (property_id) {
		case GALA_PANEL_WINDOW_WM_PROPERTY:
		g_value_set_object (value, gala_panel_window_get_wm (self));
		break;
		case GALA_PANEL_WINDOW_WINDOW_PROPERTY:
		g_value_set_object (value, gala_panel_window_get_window (self));
		break;
		case GALA_PANEL_WINDOW_HIDDEN_PROPERTY:
		g_value_set_boolean (value, gala_panel_window_get_hidden (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_gala_panel_window_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	GalaPanelWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_PANEL_WINDOW, GalaPanelWindow);
	switch (property_id) {
		case GALA_PANEL_WINDOW_WM_PROPERTY:
		gala_panel_window_set_wm (self, g_value_get_object (value));
		break;
		case GALA_PANEL_WINDOW_WINDOW_PROPERTY:
		gala_panel_window_set_window (self, g_value_get_object (value));
		break;
		case GALA_PANEL_WINDOW_HIDDEN_PROPERTY:
		gala_panel_window_set_hidden (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

